Index: Makefile.am
===================================================================
--- Makefile.am	(revision 6e1e2d0299e4210d269f7a30ec3864a8bddceabb)
+++ Makefile.am	(revision c083c3d051f3db3793a548d324e8e7d5aa9560d1)
@@ -11,7 +11,13 @@
 ## Created On       : Sun May 31 22:14:18 2015
 ## Last Modified By : Peter A. Buhr
-## Last Modified On : Sat Feb  2 16:54:42 2019
-## Update Count     : 21
+## Last Modified On : Mon May  1 16:38:04 2023
+## Update Count     : 32
 ###############################################################################
+
+# user targets:
+#  Compile compiler/runtime and run test suite.
+#  $ make check / tests [debug=yes/no] [installed=yes/no] [arch=x86/x64/arm]
+#  
+#  $ make installcheck [debug=yes/no] installed=yes [arch=x86/x64/arm]
 
 AUTOMAKE_OPTIONS = foreign    # do not require all the GNU file names
@@ -37,10 +43,15 @@
 EXTRA_DIST = LICENSE doc/man/cfa.1 libcfa/configure libcfa/Makefile.dist.am libcfa/Makefile.dist.in tools/build/distcc_hash tools/build/push2dist.sh
 
-debug=yes
+debug ?= yes
+installed ?= no
+ARCH = $(if $(arch),"arch=$(arch)")
+
 check:
-	$(MAKE) -C tests all-tests installed=no debug=${debug}
+	$(MAKE) -C tests tests installed=$(installed) debug=$(debug) $(ARCH)
+
+tests: check # synonym
 
 installcheck:
-	$(MAKE) -C tests all-tests installed=yes debug=${debug}
+	$(MAKE) -C tests tests installed=yes debug=$(debug) $(ARCH)
 
 configure-libcfa: @LIBCFA_TARGET_MAKEFILES@
Index: tests/Makefile.am
===================================================================
--- tests/Makefile.am	(revision 6e1e2d0299e4210d269f7a30ec3864a8bddceabb)
+++ tests/Makefile.am	(revision c083c3d051f3db3793a548d324e8e7d5aa9560d1)
@@ -11,7 +11,14 @@
 ## Created On       : Sun May 31 09:08:15 2015
 ## Last Modified By : Peter A. Buhr
-## Last Modified On : Mon Apr 10 23:24:02 2023
-## Update Count     : 96
+## Last Modified On : Mon May  1 17:25:24 2023
+## Update Count     : 145
 ###############################################################################
+
+# user targets:
+#  Run the complete test suite.
+#  $ make  / tests [debug=yes/no] [installed=yes/no] [arch=x86/x64/arm]
+#  
+#  Run the short (quick) test suite.
+#  $ make quick [debug=yes/no] [installed=yes/no] [arch=x86/x64/arm]
 
 AUTOMAKE_OPTIONS = foreign    # do not require all the GNU file names
@@ -20,8 +27,9 @@
 include $(top_srcdir)/tools/build/cfa.make
 
-DEFAULT_INCLUDES = -I${abs_srcdir}
-
-debug=yes
-installed=no
+DEFAULT_INCLUDES = -I$(abs_srcdir)
+
+debug ?= yes
+installed ?= no
+ARCH=$(if $(arch),"--arch=$(arch)")
 archiveerrors=
 
@@ -33,10 +41,10 @@
 timeouts=
 
-TEST_PY = python3 ${builddir}/test.py
+TEST_PY = python3 $(builddir)/test.py
 
 # applies to both programs
 # since automake doesn't have support for CFA we have to
 AM_CFLAGS = $(if $(test), 2> $(test), ) \
-	-fdebug-prefix-map=$(abspath ${abs_srcdir})= \
+	-fdebug-prefix-map=$(abspath $(abs_srcdir))= \
 	-fdebug-prefix-map=/tmp= \
 	-fno-diagnostics-show-caret \
@@ -54,5 +62,5 @@
 
 # adjust CC to current flags
-CC = LC_ALL=C $(if $(DISTCC_CFA_PATH),distcc $(DISTCC_CFA_PATH) ${ARCH_FLAGS} ,$(TARGET_CFA) ${DEBUG_FLAGS} ${ARCH_FLAGS})
+CC = LC_ALL=C $(if $(DISTCC_CFA_PATH),distcc $(DISTCC_CFA_PATH) $(ARCH_FLAGS) ,$(TARGET_CFA) $(DEBUG_FLAGS) $(ARCH_FLAGS))
 CFACC = $(CC)
 
@@ -61,8 +69,8 @@
 
 # adjusted CC but without the actual distcc call
-CFACCLOCAL = $(if $(DISTCC_CFA_PATH),$(DISTCC_CFA_PATH) ${ARCH_FLAGS} ,$(TARGET_CFA) ${DEBUG_FLAGS} ${ARCH_FLAGS})
-CFACCLINK = $(CFACCLOCAL) -quiet $(if $(test), 2> $(test), ) $($(shell echo "${@}_FLAGSLD" | sed 's/-\|\//_/g'))
-
-PRETTY_PATH=mkdir -p $(dir $(abspath ${@})) && cd ${srcdir} &&
+CFACCLOCAL = $(if $(DISTCC_CFA_PATH),$(DISTCC_CFA_PATH) $(ARCH_FLAGS) ,$(TARGET_CFA) $(DEBUG_FLAGS) $(ARCH_FLAGS))
+CFACCLINK = $(CFACCLOCAL) -quiet $(if $(test), 2> $(test), ) $($(shell echo "$(@)_FLAGSLD" | sed 's/-\|\//_/g'))
+
+PRETTY_PATH=mkdir -p $(dir $(abspath $(@))) && cd $(srcdir) &&
 
 .PHONY: list .validate .test_makeflags
@@ -93,8 +101,8 @@
 dist-hook:
 	echo "Gathering test files"
-	for file in `${TEST_PY} --list-dist`; do \
-		if test -f ${srcdir}/$${file}; then \
-			$(MKDIR_P) $$(dirname ${distdir}/$${file}); \
-			cp -df ${srcdir}/$${file} ${distdir}/$${file}; \
+	for file in `$(TEST_PY) --list-dist`; do \
+		if test -f $(srcdir)/$$(file); then \
+			$(MKDIR_P) $$(dirname $(distdir)/$$(file)); \
+			cp -df $(srcdir)/$$(file) $(distdir)/$$(file); \
 		fi; \
 	done
@@ -107,25 +115,30 @@
 
 #----------------------------------------------------------------------------------------------------------------
-all-local :
-	@+${TEST_PY} --debug=${debug} --install=${installed} --archive-errors=${archiveerrors} ${concurrent} ${timeouts} ${quick_test}
-
-all-tests :
-	@+${TEST_PY} --debug=${debug} --install=${installed} --archive-errors=${archiveerrors} ${concurrent} ${timeouts} --all # '@' => do not echo command (SILENT), '+' => allows recursive make from within python program
+
+all-local : # This name is important to automake and implies the default build target.
+	@+$(TEST_PY) --debug=$(debug) --install=$(installed) --archive-errors=$(archiveerrors) $(concurrent) $(timeouts) $(ARCH) --all # '@' => do not echo command (SILENT), '+' => allows recursive make from within python program
+
+install : all-local # PAB only
+
+tests : all-local
+
+quick :
+	@+$(TEST_PY) --debug=$(debug) --install=$(installed) --archive-errors=$(archiveerrors) $(concurrent) $(timeouts) $(ARCH) $(quick_test)
 
 mostlyclean-local :
-	find ${builddir} -not -path './__pycache__/*' -path '*.o' -delete
-	find ${builddir} -not -path './__pycache__/*' -path '*/.err/*.log' -delete
-	find ${builddir} -not -path './__pycache__/*' -path '*/.out/*.log' -delete
-	rm -f ${EXTRA_PROGRAMS}
+	find $(builddir) -not -path './__pycache__/*' -path '*.o' -delete
+	find $(builddir) -not -path './__pycache__/*' -path '*/.err/*.log' -delete
+	find $(builddir) -not -path './__pycache__/*' -path '*/.out/*.log' -delete
+	rm -f $(EXTRA_PROGRAMS)
 	rm -rf __pycache__
 
 distclean-local :
-	find ${builddir} -path '*.Po' -delete
+	find $(builddir) -path '*.Po' -delete
 
 list :
-	@+${TEST_PY} --list ${concurrent}
+	@+$(TEST_PY) --list $(concurrent)
 
 .test_makeflags:
-	@echo "${MAKEFLAGS}"
+	@echo "$(MAKEFLAGS)"
 
 .validate: .validate.cfa
@@ -133,20 +146,20 @@
 
 .validate.cfa:
-	@echo "int main() { return 0; }" > ${@}
+	@echo "int main() { return 0; }" > $(@)
 
 # automake doesn't know we still need C rules so pretend like we have a C program
 .dummy_hack.c:
-	@echo "int main() { return 0; }" > ${@}
+	@echo "int main() { return 0; }" > $(@)
 
 .dummy_hackxx.cpp:
-	@echo "int bar() { return 0; }" > ${@}
+	@echo "int bar() { return 0; }" > $(@)
 
 concurrency :
-	@+${TEST_PY} --debug=${debug}  --install=${installed} -Iconcurrent
+	@+$(TEST_PY) --debug=$(debug)  --install=$(installed) -Iconcurrent
 
 #----------------------------------------------------------------------------------------------------------------
 
 # Use for all tests, make sure the path are correct and all flags are added
-CFACOMPILETEST=$(PRETTY_PATH) $(CFACOMPILE) $(shell realpath --relative-to=${srcdir} ${<}) $($(shell echo "${@}_FLAGSCFA" | sed 's/-\|\//_/g'))
+CFACOMPILETEST=$(PRETTY_PATH) $(CFACOMPILE) $(shell realpath --relative-to=$(srcdir) $(<)) $($(shell echo "$(@)_FLAGSCFA" | sed 's/-\|\//_/g'))
 
 #----------------------------------------------------------------------------------------------------------------
@@ -156,12 +169,12 @@
 # don't use distcc to do the linking because distcc doesn't do linking
 % : %.cfa $(CFACCBIN)
-	$(CFACOMPILETEST) -c -o $(abspath ${@}).o -DIN_DIR="$(abspath $(dir ${<}))/.in/"
-	$(CFACCLINK) ${@}.o -o $(abspath ${@})
-	rm $(abspath ${@}).o
+	$(CFACOMPILETEST) -c -o $(abspath $(@)).o -DIN_DIR="$(abspath $(dir $(<)))/.in/"
+	$(CFACCLINK) $(@).o -o $(abspath $(@))
+	rm $(abspath $(@)).o
 
 # implicit rule for c++ test
 # convient for testing the testsuite itself but not actuall used
 % : %.cpp
-	$(PRETTY_PATH) $(CXXCOMPILE) $(shell realpath --relative-to=${srcdir} ${<}) -o $(abspath ${@})
+	$(PRETTY_PATH) $(CXXCOMPILE) $(shell realpath --relative-to=$(srcdir) $(<)) -o $(abspath $(@))
 
 #------------------------------------------------------------------------------
@@ -175,5 +188,5 @@
 GENERATED_CODE = declarationSpecifier gccExtensions extension attributes functions KRfunctions
 $(GENERATED_CODE): % : %.cfa $(CFACCBIN)
-	$(CFACOMPILETEST) -CFA -XCFA -p -c -fsyntax-only -o $(abspath ${@})
+	$(CFACOMPILETEST) -CFA -XCFA -p -c -fsyntax-only -o $(abspath $(@))
 
 #------------------------------------------------------------------------------
@@ -181,5 +194,5 @@
 #------------------------------------------------------------------------------
 # tests that just validate syntax and compiler output should be compared to stderr
-CFACOMPILE_SYNTAX = $(CFACOMPILETEST) -Wno-unused-variable -Wno-unused-label -c -fsyntax-only -o $(abspath ${@})
+CFACOMPILE_SYNTAX = $(CFACOMPILETEST) -Wno-unused-variable -Wno-unused-label -c -fsyntax-only -o $(abspath $(@))
 
 SYNTAX_ONLY_CODE = expression typedefRedef variableDeclarator switch numericConstants identFuncDeclarator \
@@ -187,5 +200,5 @@
 $(SYNTAX_ONLY_CODE): % : %.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX)
-	$(if $(test), cp $(test) $(abspath ${@}), )
+	$(if $(test), cp $(test) $(abspath $(@)), )
 
 # expected failures
@@ -193,37 +206,37 @@
 alloc-ERROR : alloc.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR1
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 init1-ERROR : init1.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR1
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 typedefRedef-ERR1 : typedefRedef.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR1
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 nested-types-ERR1 : nested-types.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR1
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 nested-types-ERR2 : nested-types.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR2
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 raii/memberCtors-ERR1 : raii/memberCtors.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR1
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 raii/ctor-autogen-ERR1 : raii/ctor-autogen.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR1
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 raii/dtor-early-exit-ERR1 : raii/dtor-early-exit.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR1
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 raii/dtor-early-exit-ERR2 : raii/dtor-early-exit.cfa $(CFACCBIN)
 	$(CFACOMPILE_SYNTAX) -DERR2
-	-cp $(test) $(abspath ${@})
+	-cp $(test) $(abspath $(@))
 
 # Exception Tests
@@ -231,13 +244,13 @@
 
 exceptions/%-threads : exceptions/%.cfa $(CFACCBIN)
-	$(CFACOMPILETEST) -include exceptions/with-threads.hfa -c -o $(abspath ${@}).o
-	$(CFACCLOCAL) $($(shell echo "${@}_FLAGSLD" | sed 's/-\|\//_/g')) $(abspath ${@}).o -o $(abspath ${@})
+	$(CFACOMPILETEST) -include exceptions/with-threads.hfa -c -o $(abspath $(@)).o
+	$(CFACCLOCAL) $($(shell echo "$(@)_FLAGSLD" | sed 's/-\|\//_/g')) $(abspath $(@)).o -o $(abspath $(@))
 
 # Linking tests
 # Meta tests to make sure we see linking errors (can't compile with -O2 since it may multiply number of calls)
 linking/linkerror : linking/linkerror.cfa $(CFACCBIN)
-	$(CFACOMPILETEST) -O0 -c -o $(abspath ${@}).o
-	$(CFACCLINK)  -O0 ${@}.o -o $(abspath ${@})
-	rm $(abspath ${@}).o
+	$(CFACOMPILETEST) -O0 -c -o $(abspath $(@)).o
+	$(CFACCLINK)  -O0 $(@).o -o $(abspath $(@))
+	rm $(abspath $(@)).o
 
 #------------------------------------------------------------------------------
